/*
 ķ
   Program..: NUMPAD.PRG                            
   Author...: Roger J. Donnay                       
   Date.....: Dec  4, 2000                          
   Modified by Bruce Neuman                         
   Images by Blake Neuman                           
   Date.....: june 10, 2011                         
 Ľ
*/

#include 'inkey.ch'
#include 'dccolor.ch'
#include 'appevent.ch'
#include 'gra.ch'
#include 'xbp.ch'
#include 'dcmsg.ch'
#include 'dcdialog.ch'


FUNCTION PopNumPad( nValue,cText )

LOCAL GetList := {}, GetOptions, nSaveValue, oCancelButton

PRIVATE lFirstTime := .t.

DEFAULT nValue := 0
DEFAULT cText := 'Enter Value'
nSaveValue := nValue

IF nValue = 0
  cValue := ''
ELSE
  cValue := Alltrim(Str(nValue))
        cValue := PadL(cValue,16)
ENDIF

@   0,   5 DCSAY  cText  FONT '20.Arial Bold' SAYCENTER saycolor 10  SIZE 270,40 PIXEL  //Courier New

@  50,   0 DCGET cValue FONT '20.Courier New Bold' SIZE 270,40 PIXEL ;     //Courier New
    EDITPROTECT {||.t.} ID 'ACCUM'


@  100,  0 DCPUSHBUTTON CAPTION 2107 FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
   ACTION {||Accum(7,@cValue,GetList)} ;
   ACCELKEY Asc('7') ;
   EVAL _FlashBlock(2107,2207)

@  100, 60 DCPUSHBUTTON CAPTION 2108 FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
   ACTION {||Accum(8,@cValue,GetList)} ;
   ACCELKEY Asc('8') ;
   EVAL _FlashBlock(2108,2208)

@  100,120 DCPUSHBUTTON CAPTION 2109 FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
   ACTION {||Accum(9,@cValue,GetList)} ;
   ACCELKEY Asc('9') ;
   EVAL _FlashBlock(2109,2209)
//negative
 @ 100,190 DCPUSHBUTTON CAPTION 2112 FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
   ACTION {||Accum(11,@cValue,GetList)} ;
   ACCELKEY 45 ;  // negative sign
   EVAL _FlashBlock(2112,2212)

@ 160,  0 DCPUSHBUTTON CAPTION 2104 FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
   ACTION {||Accum(4,@cValue,GetList)} ;
   ACCELKEY Asc('4') ;
   EVAL _FlashBlock(2104,2204)

@ 160, 60 DCPUSHBUTTON CAPTION 2105 FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
   ACTION {||Accum(5,@cValue,GetList)} ;
   ACCELKEY Asc('5') ;
   EVAL _FlashBlock(2105,2205)

@ 160,120 DCPUSHBUTTON CAPTION 2106 FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
   ACTION {||Accum(6,@cValue,GetList)} ;
   ACCELKEY Asc('6') ;
   EVAL _FlashBlock(2106,2206)

@ 220,  0 DCPUSHBUTTON CAPTION 2101 FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
   ACTION {||Accum(1,@cValue,GetList)} ;
   ACCELKEY Asc('1') ;
   EVAL _FlashBlock(2101,2201)

@ 220, 60 DCPUSHBUTTON CAPTION 2102 FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
   ACTION {||Accum(2,@cValue,GetList)} ;
   ACCELKEY Asc('2') ;
   EVAL _FlashBlock(2102,2202)

@ 220,120 DCPUSHBUTTON CAPTION 2103 FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
   ACTION {||Accum(3,@cValue,GetList)} ;
   ACCELKEY Asc('3') ;
   EVAL _FlashBlock(2103,2203)

@ 280,  0 DCPUSHBUTTON CAPTION 2100 FONT '16.Arial Bold' SIZE 110,50 PIXEL ;
   ACTION {||Accum(0,@cValue,GetList)} ;
   ACCELKEY Asc('0') ;
   EVAL _FlashBlock(2100,2200)

@ 280,120 DCPUSHBUTTON CAPTION 2110 FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
   ACTION {||Accum(10,@cValue,GetList)} ;
   ACCELKEY 46 ;   // decimal point
   EVAL _FlashBlock(2110,2210)
/*
@ 280,120 DCPUSHBUTTON CAPTION 2112 FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
   ACTION {||Accum(11,@cValue,GetList)} ;
   ACCELKEY 45 ;  // negative sign
   EVAL _FlashBlock(2112,2212)
*/
@ 340,  0 DCPUSHBUTTON CAPTION 2111 FONT '16.Arial Bold' SIZE 80,50 PIXEL ;
   ACTION {||Accum(12,@cValue,GetList)} ;
   ACCELKEY { 67, 99 } ;   // clear
   EVAL _FlashBlock(2111,2211)

@ 340, 90 DCPUSHBUTTON CAPTION 2113 FONT '16.Arial Bold' SIZE 80,50 PIXEL ;
   ACTION {||Accum(13,@cValue,GetList)} ;
   ACCELKEY 8 ;   //backspace
   EVAL _FlashBlock(2113,2213)

@ 220,190 DCPUSHBUTTON CAPTION 2114 FONT '12.Arial Bold' SIZE 80,110 PIXEL ;
   ACCELKEY 13 ;  //ok
   ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}

@ 160,190 DCPUSHBUTTON CAPTION 2115 FONT '12.Arial Bold' SIZE 80,50 PIXEL ;
   ACTION {||lReturn := .f., DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList)} ;
   ACCELKEY 27 ;   // Esc or cancel
   OBJECT oCancelButton

DCGETOPTIONS ;
   ;//ORIGIN XBPDLG_ORIGIN_MOUSE ;
         COLOR XBPSYSCLR_TRANSPARENT;
         bitmap 2301 ;
         NOMINBUTTON ;
         NOMAXBUTTON

DCREAD GUI ;
   FIT ;
         MODAL ;
   TITLE 'Numeric Pad' ;
   SETFOCUS @oCancelButton ;
   TO lStatus ;
   OPTIONS GetOptions ;
   ;//EVAL {|o|o:setPos({o:currentPos()[1],o:currentPos()[2]-o:currentSize()[2]}), ;
   ;//         o:show() }

IF !lStatus
  nValue := nSaveValue
ELSE
  nValue := Val(cValue)
ENDIF

RETURN nValue

* ----------------

STATIC FUNCTION Accum ( nKey, cValue, GetList )

IF lFirstTime
  cValue := ''
ELSE
  cValue := Alltrim(cValue)
ENDIF

lFirstTime := .f.

IF nKey >= 0 .AND. nKey <= 9

  cValue += Alltrim(Str(nKey))

ELSEIF nKey == 10 // Decimal key

  cValue := StrTran(cValue,'.','')
  cValue += '.'

ELSEIF nKey == 11 // Minus Key

  IF Left(cValue,1) == '-'
    cValue := Substr(cValue,2)
  ELSE
    cValue := '-' + cValue
  ENDIF

ELSEIF nKey == 12 // Clear

  cValue := ''

ELSEIF nKey == 13 // Backspace

  cValue := Substr(cValue,1,Len(cValue)-1)

ENDIF

cValue := PadL(cValue,16)

DC_GetRefresh(GetList,'ACCUM')
SetAppFocus(DC_GetObject(GetList,'ACCUM'))   // <<<<<<<<<<< add this

RETURN nil

* ----------------

STATIC FUNCTION _FlashBlock( n1, n2 )

RETURN {|o|o:lbdown := {|a,b,x|_FlashBlock2(x,n1,n2)}}

* ----------------

STATIC FUNCTION _FlashBlock2( oXbp, n1, n2 )

_Flash( oXbp, n1, n2 )

RETURN nil

* -----------

STATIC FUNCTION _Flash( oButton, cCaption1, cCaption2 )
oButton:setFontCompoundName('12.Arial Bold')
oButton:setCaption(DC_GetBitmap(cCaption2))
Sleep(10)
oButton:setFontCompoundName('16.Arial Bold')
oButton:setCaption(DC_GetBitmap(cCaption1))


/*
oButton:setFontCompoundName('12.Arial Bold')
oButton:setCaption(DC_GetBitmap(cCaption2))
Sleep(5)
oButton:setFontCompoundName('16.Arial Bold')
oButton:setCaption(DC_GetBitmap(cCaption1))
Sleep(5)
oButton:setFontCompoundName('12.Arial Bold')
oButton:setCaption(DC_GetBitmap(cCaption2))
Sleep(5)
oButton:setFontCompoundName('16.Arial Bold')
oButton:setCaption(DC_GetBitmap(cCaption1))
Sleep(5)
*/
RETURN nil